#include <system.h> 
#include <ctype.h>
#include "serial.h"
#include "spi.h"
#include "serial_flash.h"
//#include "iocnt.h"
#include "lcd_str.h"
#define _SDEBUG_
#include "sdebug.h"


#pragma CLOCK_FREQ	 8000000

#pragma DATA _CONFIG, _WDT_OFF & _INTRC_OSC_NOCLKOUT &_MCLRE_OFF


#ifdef _SDEBUG_
char buff[20];
#endif


//lcd default value
char pos_x=0,pos_y=0;
short str_color=0x0000, bg_color=0x0FFF;


////////////////////////////////////////////////////////////////
// Interrupt service routine. Branch off to different interrupts
////////////////////////////////////////////////////////////////	
//Fifo Data
char dFifo[16];
char wCnt=0;
char rCnt=0;
char wSize=0;

void interrupt( void )
{
	char data;
	//Handle RS232 Recieve interrupt
	if( pir1 & (1<< RCIF) )
	{
		clear_bit( pir1, RCIF ); //clear RS232 Recieve interrupt bit
		//Ńf[^M
		data = RsGetc();
		//FifoɊi[
		if(wSize<16){
			dFifo[wCnt]=data;
			wCnt=(wCnt+1) & 0x0f;
			wSize++;
		}		
	}
}

void IoInit()
{
	//Port Setting
	osccon = 0x75;	//RCU8MHzɐݒ
	trisa = 0x00;
	trisb = 0x30;
	trisc = 0x00;
	porta=0x00;
	portb=0x00;
	portc=0x41;
	ansel=0;
	anselh=0;
}

//GXP[vV[PX̏
void PostChar(char c, char pos_x1, char pos_y1)
{
	static bool IsEscape=false;	//GXP[vV[PXTRUE
	static char EscCnt=0;		//GXP[vV[PX̕iő8j
	static char EscBuff[10];
	char x,y,i,ch;
	if(!IsEscape){
		if(c==0x1b){
			IsEscape=true;
			EscCnt=0;
			pos_x--;
		}else{
			DrawChr(c,pos_x1 ,pos_y1, str_color, bg_color);
		}
				//LcdCls();
			//DrawChr(c,pos_x1 ,pos_y1, str_color);
	}else{
		if(isalpha(c)){
			//EscapȅI
			switch(c){
			case 'm':
				x=0;
				for(i=1;i<=EscCnt;i++){
					ch=EscBuff[i];
					if(ch=='m')
						break;
					if((ch>='0')&&(ch<='9'))
						x=x*10+(ch-'0');
				}
				switch(x)
				{
					case 0:
						str_color = 0x0000;
						break;
					case 17:
						str_color = 0x0F00;
						break;
					case 18:
						str_color = 0x000F;
						break;
					case 19:
						str_color = 0x0F0F;
						break;
					case 20:
						str_color = 0x00F0;
						break;
					case 21:
						str_color = 0x0FF0;
						break;
					case 22:
						str_color = 0x00FF;
						break;
					case 23:
						str_color = 0x0FFF;
						break;
					case 30:
						str_color = 0x0000;
						break;
					case 31:
						str_color = 0x0F00;
						break;
					case 32:
						str_color = 0x00F0;
						break;
					case 33:
						str_color = 0x0FF0;
						break;
					case 34:
						str_color = 0x000F;
						break;
					case 35:
						str_color = 0x0F0F;
						break;
					case 36:
						str_color = 0x00FF;
						break;
					case 37:
						str_color = 0x0FFF;
						break;
					case 40:
						bg_color = 0x0000;
						break;
					case 41:
						bg_color = 0x0F00;
						break;
					case 42:
						str_color = 0x00F0;
						break;
					case 43:
						bg_color = 0x0FF0;
						break;
					case 44:
						bg_color = 0x000F;
						break;
					case 45:
						bg_color = 0x0F0F;
						break;
					case 46:
						bg_color = 0x00FF;
						break;
					case 47:
						bg_color = 0x0FFF;
						break;
				}
				break;
			case 'M':
				if(pos_y>0)
				pos_y--;
				break;
			case 'L':
				pos_y++;
				break;
			case 'J':	//Clear Screen
				LcdCls();
				pos_x=pos_y=0;
				break;
				/*
			case 'H':	//Goto Cursol
				y=0;
				x=0;
				//Get y Value
				for(i=1;i<=EscCnt;i++){
					ch=EscBuff[i];
					if(ch==';')
						break;
					if((ch>='0')&&(ch<='9'))
						y=y*10+(ch-'0');
				}
				//Get x Value
				for(i++;i<=EscCnt;i++){
					ch=EscBuff[i];
					if((ch>='0')&&(ch<='9'))
						x=x*10+(ch-'0');
				}
				LcdXy(x,y);
				break;
			case 'l':	//Cursol Off
				if(EscBuff[1]=='>')
					LcdDisplayMode(1,0,0);
				break;
			case 'h':	//Cursol On
				if(EscBuff[1]=='>')
					LcdDisplayMode(1,1,1);
				break;
				*/
			}
			IsEscape=false;
			EscCnt=0;
			pos_x--;
		}else{
			if(EscCnt==0){
				if(c!='['){
					IsEscape=false;
					pos_x--;
					return;
				}
			}
			if(EscCnt<10){
				EscBuff[EscCnt]=c;
				EscCnt++;
				pos_x--;
			}
		}
	}
		
}

void PostStr(char *str)
{
	while(*str){
		PostChar(*str, pos_x++, pos_y++);
		str++;
	}
}


//*****************************************************
//  MAIN PROGRAM
//*****************************************************
void main() 
{
	int i,j;
	char led=0;
	char wdat;
	char rdat[64];
	IoInit();
	RsInit();		//19200bps
	set_bit( pie1, RCIE ); //enable RS232 Interrupt
	set_bit( intcon, PEIE );
	set_bit( intcon, GIE );
	
	SpiInit();
	Flash_Init();
	LCD_Init();
	prints("PIC Graphic LCD monitor.\r\n");
	wdat = Flash_Rdid();
	RsPutc(wdat/100+'0');wdat%=100;
	RsPutc(wdat/10+'0');wdat%=10;
	RsPutc(wdat+'0');
	prints("\r\n");
	/*
	wdat = Flash_Read_byte(0);
	RsPutc(wdat/100+'0');wdat%=100;
	RsPutc(wdat/10+'0');wdat%=10;
	RsPutc(wdat+'0');
	prints("\r\n");
	*/
	/*
	Flash_Read_Str(0,rdat,64);
	for(i=0;i<64;i++)
	{
		RsPutc(rdat[i]/100+'0');rdat[i]%=100;
		RsPutc(rdat[i]/10+'0');rdat[i]%=10;
		RsPutc(rdat[i]+'0');
		if(((i+1)%8)==0 & i)
		{
			prints("\r\n");
		}
		else
		{
			prints(", ");
		}
	}
	*/
	//main loop
	while (1) {
		if(wSize){
			//FIFO̓ǂݏo
			wdat=dFifo[rCnt];
			rCnt=(rCnt+1)&0x0f;
			wSize--;
			PostChar(wdat, (pos_x++)%22, pos_y%16);
			if(pos_x>21)
			{
				pos_x=0;
				if(pos_y==15)
				{
					pos_y=0;
				}
				else
				{
					pos_y++;
				}
			}
			RsPutc(wdat);

		}
	}
}
